/* Beispiel fuer Java-Datenstrukturen
 * "Warengruppe" zur Vorlesung "Softwaretechnologie".
 * (c) Heinrich Hussmann, Uwe Aßmann, TU Dresden, 2013 

 * Diese Version des Beispiels "Warengruppe" verwendet TreeSet.
 * Dazu ist die Einfuehrung einer Vergleichsoperation auf Artikeln noetig.
 * @Version 2.0 Generics
*/

import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;

class Artikel implements Comparable<Artikel> {

  private String name;
  private int preis;
  
  public Artikel (String name, int preis) {
    this.name = name;
    this.preis = preis;
  }
  
  public int preis() {
    return preis;
  }
  
  public String toString() {
    return name+"("+preis+")";
  }
  
  public int compareTo (Artikel o) {
    return name.compareTo(o.name);
  }
}

class Warengruppe3 {

  private String name;
  private String lagerplatz;
  private Set<Artikel> inhalt;
  
  public Warengruppe3 (String name, String lagerplatz) {
    this.name = name;
    this.lagerplatz = lagerplatz;
    this.inhalt = new TreeSet<Artikel>();
  }
        
  public void add (Artikel a) {
    inhalt.add(a);
  }
  
  public int anzahl() {
    return inhalt.size();
  }
  
  public String toString() {
    String s = "Warengruppe "+name+", Lagerplatz "+lagerplatz+"\n";
    Iterator<Artikel> it = inhalt.iterator();
    while (it.hasNext()) {
      s += " "+it.next();
    };
    s += "\nAnzahl Artikel in Warengruppe: "+inhalt.size()+"\n";
    return s;
}
  
  
  public static void main (String[] args) {
      
    Warengruppe3 w1 = new Warengruppe3("Moebel","L1");
    w1.add(new Artikel("Tisch",200));
    w1.add(new Artikel("Stuhl",100));
    w1.add(new Artikel("Schrank",300));
    w1.add(new Artikel("Tisch",200));
    System.out.println(w1);
    
    Artikel tisch = new Artikel("Tisch",200);
    Artikel stuhl = new Artikel("Stuhl",100);
    Artikel schrank = new Artikel("Schrank",300);
  
    Warengruppe3 w2 = new Warengruppe3("Moebel","L2");
    w2.add(tisch);
    w2.add(stuhl);
    w2.add(schrank);
    w2.add(tisch);
    System.out.println(w2);

  }
  
}
